#include "General.h"
#include "MTCP.h"

extern "C" {

void
mtcp_init() {
  MTCP::Init();
}

pid_t
mtcp_fork() {
  return( MTCP::Fork() );
}

int
mtcp_socket(int family, int type, int protocol) {
  return( MTCP::Socket(family, type, protocol) );
}

int
mtcp_connect(int sockfd, struct sockaddr* servaddr, int addrlen) {
  return( MTCP::Connect(sockfd, servaddr, addrlen) );
}

int
mtcp_setsockopt(int sockfd, int level, int optname, char* optval, int optlen) {
  return( MTCP::SetSockOpt(sockfd, level, optname, optval, optlen) );
}

int
mtcp_getsockopt(int sockfd, int level, int optname, char* optval, int* optlen) {
  return( MTCP::GetSockOpt(sockfd, level, optname, optval, optlen) );
}

int
mtcp_getpeername(int sockfd, struct sockaddr* peer, int* addrlen) {
  return( MTCP::GetPeerName(sockfd, peer, addrlen) );
}

int
mtcp_getsockname(int sockfd, struct sockaddr* peer, int* addrlen) {
  return( MTCP::GetSockName(sockfd, peer, addrlen) );
}

int
mtcp_close(int fd) {
  return( MTCP::Close(fd) );
}

int
mtcp_bind(int sockfd, struct sockaddr* myaddr, int addrlen) {
  return( MTCP::Bind(sockfd, myaddr, addrlen) );
}

int
mtcp_accept(int sockfd, struct sockaddr* peer, int* addrlen) {
  return( MTCP::Accept(sockfd, peer, addrlen) );
}

void
mtcp_beginmessage(int sockfd) {
  MTCP::BeginMessage(sockfd);
}

void
mtcp_endmessage(int sockfd) {
  MTCP::EndMessage(sockfd);
}

int
mtcp_write(int sockfd, char* buff, unsigned int nbytes) {
  return( MTCP::Write(sockfd, buff, nbytes) );
}

}
