#ifndef _MTCP_H
#define _MTCP_H

#ifndef _MTCP_IMPLEMENTATION
#include "mrmp-c.h"
#endif

#define AF_RMP       (AF_MAX+1)
#define PF_RMP       AF_RMP

#define SOL_MTCP     0xfffe

#define SO_MINSIZE   0xf000
#define SO_TTL       0xf001
#define SO_PORT      0xf002
#define SO_IPPORT    0xf003
#define SO_IPADDR    0xf004
#define SO_UNICAST   0xf005
#define SO_JOINFLAGS 0xf006
#define SO_QOS       0xf007
#define SO_GROUPNAME 0xf008

struct sockaddr_rmp {
  short         srmp_family; /* AF_RMP */
  unsigned long srmp_min_size;
  unsigned long srmp_ttl;
  unsigned long srmp_port;
  unsigned long srmp_ipport;
  unsigned long srmp_ipaddr;
  unsigned long srmp_unicast;
  unsigned long srmp_join_flags;
  unsigned long srmp_qos;
  char          srmp_groupname[256];
};

extern void  mtcp_init();
extern pid_t mtcp_fork();
extern int   mtcp_socket(int, int, int);
extern int   mtcp_connect(int, struct sockaddr*, int);
extern int   mtcp_setsockopt(int, int, int, char*, int);
extern int   mtcp_getsockopt(int, int, int, char*, int*);
extern int   mtcp_getpeername(int, struct sockaddr*, int*);
extern int   mtcp_getsockname(int, struct sockaddr*, int*);
extern int   mtcp_close(int);
extern int   mtcp_bind(int, struct sockaddr*, int);
extern int   mtcp_accept(int, struct sockaddr*, int*);
extern void  mtcp_beginmessage(int);
extern void  mtcp_endmessage(int);
extern int   mtcp_write(int, char*, unsigned int);

#ifndef _MTCP_IMPLEMENTATION
#define fork()                mtcp_fork()
#define socket(x,y,z)         mtcp_socket(x,y,z)
#define connect(x,y,z)        mtcp_connect(x,y,z)
#define setsockopt(v,w,x,y,z) mtcp_setsockopt(v,w,x,y,z)
#define getsockopt(v,w,x,y,z) mtcp_getsockopt(v,w,x,y,z)
#define getpeername(x,y,z)    mtcp_getpeername(x,y,z)
#define getsockname(x,y,z)    mtcp_getsockname(x,y,z)
#define close(x)              mtcp_close(x)
#define bind(x,y,z)           mtcp_bind(x,y,z)
#define accept(x,y,z)         mtcp_accept(x,y,z)
#define beginmessage(x)       mtcp_beginmessage(x)
#define endmessage(x)         mtcp_endmessage(x)
#define write(x,y,z)          mtcp_write(x,y,z)
#endif

#endif
