#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>

#include "mtcp.h"

main(int argc, char** argv) {
  int SocketID;
  struct sockaddr_rmp rmpaddr;

  char buffer[100];
  int length;

  mtcp_init();
  
  if((SocketID = socket(AF_RMP,0,0)) == -1) {
    fprintf(stderr, "MTCP::Socket failed.\n");
    fflush(stderr);
    exit(1);
  }
  
  memset((char*)&rmpaddr, (char)0, sizeof(struct sockaddr_rmp));
  rmpaddr.srmp_family     = AF_RMP;
  rmpaddr.srmp_min_size   = htonl(1);
  rmpaddr.srmp_ttl        = htonl(1);
  rmpaddr.srmp_port       = htonl(0);
  rmpaddr.srmp_ipport     = htonl(0);
  rmpaddr.srmp_ipaddr     = htonl(0);
  rmpaddr.srmp_unicast    = htonl(FALSE);
  rmpaddr.srmp_join_flags = htonl(FORCE_FORMATION);
  rmpaddr.srmp_qos        = htonl(QOS_TOTALLY_ORDERED);
  strcpy(rmpaddr.srmp_groupname, "multitcp_test");
  if (bind(SocketID, (struct sockaddr*)&rmpaddr, sizeof(rmpaddr)) == -1) {
    fprintf(stderr, "MTCP::Bind failed.\n");
    fflush(stderr);
    exit(1);
  }
  SocketID = accept(SocketID, 0, 0);
  
  printf("RECEIVER\n"); fflush(stdout);
  for (;;) {
    length = read(SocketID, buffer, 100);
    if (length != 0) {
      write(STDOUT_FILENO, buffer, length);
    }
  }
  
  fprintf(stderr, "Test Complete.");
  fflush(stderr);
}
